From 7fa1ee007d96d161cea414be47fab015bf2a678e Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jan 27 2017 17:11:01 +0000
Subject: [PATCH 677/1001] More Python3 compatibility


---

diff --git a/hubs/app.py b/hubs/app.py
index f352afd..f75b404 100755
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -5,6 +5,7 @@ import functools
 import json
 import logging
 import os
+import six
 from six.moves.urllib import parse as urlparse
 
 import flask
@@ -20,7 +21,7 @@ import hubs.stream
 
 import datanommer.models
 
-from hubs.utils import username2avatar
+from hubs.utils import username2avatar, to_str
 
 app = flask.Flask(__name__)
 
@@ -546,7 +547,7 @@ def notifications(user):
         return flask.jsonify(notifications)
 
     if flask.request.method == 'POST':
-        data = json.loads(flask.request.data)
+        data = json.loads(to_str(flask.request.data))
         user = hubs.models.User.by_username(session, user)
         if not user:
             return flask.abort(400)
@@ -756,7 +757,7 @@ def plus_plus_status(user):
 def plus_plus_update_bool_helper(val):
     if isinstance(val, bool):
         return val
-    elif isinstance(val, (str, unicode)):
+    elif isinstance(val, six.string_types):
         fmt_str = str(val).replace("'", "").replace('"', '').lower()
         return fmt_str in ("yes", "true", "t", "1")
     else:
diff --git a/hubs/tests/test_api/test_notifications.py b/hubs/tests/test_api/test_notifications.py
index 8440baf..66f8d99 100644
--- a/hubs/tests/test_api/test_notifications.py
+++ b/hubs/tests/test_api/test_notifications.py
@@ -4,6 +4,7 @@ from six.moves.urllib.parse import urlparse
 import hubs.tests
 import hubs.models
 from hubs.app import app
+from hubs.utils import to_str
 
 
 class TestGetNotifications(hubs.tests.APPTest):
@@ -15,7 +16,7 @@ class TestGetNotifications(hubs.tests.APPTest):
         with hubs.tests.auth_set(app, self.user):
             resp = self.app.get('/{}/notifications/'.format(name))
         self.assertEqual(resp.status_code, 200)
-        data = json.loads(resp.data)
+        data = json.loads(to_str(resp.data))
         self.assertEqual(data, [])
 
     def test_get_notifications_valid_name(self):
@@ -24,7 +25,7 @@ class TestGetNotifications(hubs.tests.APPTest):
                 self.user.username))
 
         self.assertEqual(resp.status_code, 200)
-        data = json.loads(resp.data)
+        data = json.loads(to_str(resp.data))
         self.assertEqual(len(data), 1)
 
         for saved in data:
@@ -67,7 +68,7 @@ class TestPostNotifications(hubs.tests.APPTest):
                 data=json.dumps(self.valid_payload))
 
         self.assertEqual(resp.status_code, 200)
-        data = json.loads(resp.data)
+        data = json.loads(to_str(resp.data))
         self.assertTrue(isinstance(data, dict))
 
         notification = data['notification']
diff --git a/hubs/tests/test_fedora_hubs_flask_api.py b/hubs/tests/test_fedora_hubs_flask_api.py
index ea4b6b9..d94ef4a 100644
--- a/hubs/tests/test_fedora_hubs_flask_api.py
+++ b/hubs/tests/test_fedora_hubs_flask_api.py
@@ -11,6 +11,7 @@ from werkzeug.datastructures import ImmutableMultiDict
 import hubs
 from hubs import tests
 from hubs.app import app
+from hubs.utils import to_str
 
 import hubs.models
 
@@ -287,10 +288,10 @@ class HubsAPITest(hubs.tests.APPTest):
         with tests.auth_set(app, user):
             url = '/visit/decause'
             result = self.app.get(url)
-            self.assertEqual(json.loads(result.data), {"count": 0})
+            self.assertEqual(json.loads(to_str(result.data)), {"count": 0})
 
             result = self.app.post(url)
-            self.assertEqual(json.loads(result.data), {"count": 1})
+            self.assertEqual(json.loads(to_str(result.data)), {"count": 1})
 
             # accessing my hub shouldn't increment the count
             url = 'visit/ralph'
@@ -415,7 +416,7 @@ class HubsAPITest(hubs.tests.APPTest):
             "total": 0,
             "username": "decause"
         }
-        self.assertEqual(json.loads(result.data), expected)
+        self.assertEqual(load_json(result.data), expected)
 
     @mock.patch('requests.post', side_effect=mocked_requests_post)
     def test_plus_plus_post_increment_valid(self, mock_post):
@@ -431,7 +432,7 @@ class HubsAPITest(hubs.tests.APPTest):
                 "total": 1,
                 "username": "decause"
             }
-            self.assertEqual(json.loads(result.data), expected)
+            self.assertEqual(load_json(result.data), expected)
 
     @mock.patch('requests.post', side_effect=mocked_requests_post)
     def test_plus_plus_post_increment_myself_error(self, mock_post):
diff --git a/hubs/tests/test_widgets/test_about.py b/hubs/tests/test_widgets/test_about.py
index f67e476..2e358d0 100644
--- a/hubs/tests/test_widgets/test_about.py
+++ b/hubs/tests/test_widgets/test_about.py
@@ -3,6 +3,7 @@ import json
 from nose.tools import assert_dict_equal
 
 import hubs.tests.test_widgets
+from hubs.utils import to_str
 
 
 class TestBadges(hubs.tests.test_widgets.WidgetTest):
@@ -12,7 +13,7 @@ class TestBadges(hubs.tests.test_widgets.WidgetTest):
         widget = self.widget_instance('ralph', self.plugin)
         response = self.app.get('/ralph/%i/json/' % widget.idx)
         assert response.status_code == 200, response.status_code
-        data = json.loads(response.data)
+        data = json.loads(to_str(response.data))
         del data['data']['widget_url']
         self.assertDictEqual(data['data'], {
             u'edit_url': u'/ralph/56/edit',
diff --git a/hubs/tests/test_widgets/test_badges.py b/hubs/tests/test_widgets/test_badges.py
index b3b5197..b7831c0 100644
--- a/hubs/tests/test_widgets/test_badges.py
+++ b/hubs/tests/test_widgets/test_badges.py
@@ -2,6 +2,7 @@ import json
 
 from mock import patch, MagicMock
 import hubs.tests.test_widgets
+from hubs.utils import to_str
 
 
 class TestBadges(hubs.tests.test_widgets.WidgetTest):
@@ -11,7 +12,7 @@ class TestBadges(hubs.tests.test_widgets.WidgetTest):
         widget = self.widget_instance('ralph', self.plugin)
         response = self.app.get('/ralph/%i/json/' % widget.idx)
         assert response.status_code == 200, response.status_code
-        data = json.loads(response.data)
+        data = json.loads(to_str(response.data))
         self.assertEquals(data['plugin'], 'badges')
         self.assertIn('assertions', data['data'].keys())
 
@@ -45,4 +46,4 @@ class TestBadges(hubs.tests.test_widgets.WidgetTest):
         msg = {'topic': 'hubs.widget.update', 'msg': {'widget': {'id': widget.idx + 1}}}
         module = hubs.widgets.registry[widget.plugin]
         result = module.should_invalidate(msg, self.session, widget)
-        self.assertTrue(result)
\ No newline at end of file
+        self.assertTrue(result)
diff --git a/hubs/tests/test_widgets/test_fedmsgstats.py b/hubs/tests/test_widgets/test_fedmsgstats.py
index c88b7a4..5f16417 100644
--- a/hubs/tests/test_widgets/test_fedmsgstats.py
+++ b/hubs/tests/test_widgets/test_fedmsgstats.py
@@ -1,6 +1,7 @@
 import json
 
 import hubs.tests.test_widgets
+from hubs.utils import to_str
 
 
 class TestFedmsgStats(hubs.tests.test_widgets.WidgetTest):
@@ -10,7 +11,7 @@ class TestFedmsgStats(hubs.tests.test_widgets.WidgetTest):
         widget = self.widget_instance('ralph', self.plugin)
         response = self.app.get('/ralph/%i/json/' % widget.idx)
         assert response.status_code == 200, response.status_code
-        data = json.loads(response.data)
+        data = json.loads(to_str(response.data))
         del data['data']['widget_url']
         self.assertDictEqual(data['data'], {
             u'edit_url': u'/ralph/37/edit',
diff --git a/hubs/tests/test_widgets/test_library.py b/hubs/tests/test_widgets/test_library.py
index bd01019..58376c4 100644
--- a/hubs/tests/test_widgets/test_library.py
+++ b/hubs/tests/test_widgets/test_library.py
@@ -2,6 +2,7 @@ import json
 
 import hubs.tests.test_widgets
 import hubs.models
+from hubs.utils import to_str
 
 class TestLibrary(hubs.tests.test_widgets.WidgetTest):
     plugin = 'library'  # The name in hubs.widgets.registry
@@ -10,7 +11,7 @@ class TestLibrary(hubs.tests.test_widgets.WidgetTest):
         widget = self.widget_instance('ralph', self.plugin)
         response = self.app.get('/ralph/%i/json/' % widget.idx)
         self.assertEqual(response.status_code, 200)
-        data = json.loads(response.data)
+        data = json.loads(to_str(response.data))
         expected_dict = {
             "config": {
                 "urls": "ralph/"
diff --git a/hubs/tests/test_widgets/test_meetings.py b/hubs/tests/test_widgets/test_meetings.py
index 7184796..5df4bd5 100644
--- a/hubs/tests/test_widgets/test_meetings.py
+++ b/hubs/tests/test_widgets/test_meetings.py
@@ -1,6 +1,7 @@
 import json
 
 import hubs.tests.test_widgets
+from hubs.utils import to_str
 
 
 class TestMeetings(hubs.tests.test_widgets.WidgetTest):
@@ -11,7 +12,7 @@ class TestMeetings(hubs.tests.test_widgets.WidgetTest):
         widget = self.widget_instance(team, self.plugin)
         response = self.app.get('/%s/%i/json/' % (team, widget.idx))
         self.assertEqual(200, response.status_code)
-        data = json.loads(response.data)
+        data = json.loads(to_str(response.data))
         calendar_name = data['data']['calendar']
         self.assertIn(team, calendar_name)
 
@@ -21,4 +22,4 @@ class TestMeetings(hubs.tests.test_widgets.WidgetTest):
         response = self.app.get('/%s/%i/' % (team, widget.idx))
         self.assertEqual(200, response.status_code)
         self.assertIn('i18n', response.data)
-        self.assertIn('<strong>Request A New Meeting</strong>', response.data)
\ No newline at end of file
+        self.assertIn('<strong>Request A New Meeting</strong>', response.data)
diff --git a/hubs/utils.py b/hubs/utils.py
index ed00d80..f5166bd 100755
--- a/hubs/utils.py
+++ b/hubs/utils.py
@@ -1,9 +1,11 @@
+import json
 import logging
 from hashlib import sha256
 
 import arrow
 import markdown
 import requests
+import six
 
 from six.moves.urllib_parse import urlencode
 
@@ -80,3 +82,14 @@ def _github_results(url, auth):
                     part.split('; ')[0][1:-1],
                 ) for part in field.split(', ')
             ])
+
+
+def to_str(data):
+    """
+    A Python3-compatible way to return a string from a string or a UTF8-encoded
+    bytestring. Werkzeug responses are bytestrings on Python 3.
+    """
+    if isinstance(data, six.binary_type):
+        return data.decode('utf-8')
+    else:
+        return data

